---
title: SubtleCrypto.decrypt()
slug: Web/API/SubtleCrypto/decrypt
tags:
  - API
  - Decrypt
  - Method
  - Reference
  - Référence(2)
  - SubtleCrypto
  - Web Crypto API
---
<p>{{APIRef("Web Crypto API")}}{{SecureContext_header}}</p>

<p>The <code><strong>decrypt()</strong></code> method of the {{domxref("SubtleCrypto")}} interface decrypts some encrypted data. It takes as arguments a {{glossary("key")}} to decrypt with, some optional extra parameters, and the data to decrypt (also known as "ciphertext"). It returns a {{jsxref("Promise")}} which will be fulfilled with the decrypted data (also known as "plaintext").</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>result</em> = crypto<code>.subtle.decrypt(<em>algorithm</em>, <em>key</em>, <em>data</em>)</code>;
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><em><code>algorithm</code></em> is an object specifying the <a href="#Supported_algorithms">algorithm</a> to be used, and any extra parameters as required. The values given for the extra parameters must match those passed into the corresponding {{domxref("SubtleCrypto.encrypt()", "encrypt()")}} call.

  <ul>
   <li>To use <a href="#RSA-OAEP">RSA-OAEP</a>, pass an {{domxref("RsaOaepParams")}} object.</li>
   <li>To use <a href="#AES-CTR">AES-CTR</a>, pass an {{domxref("AesCtrParams")}} object.</li>
   <li>To use <a href="#AES-CBC">AES-CBC</a>, pass an {{domxref("AesCbcParams")}} object.</li>
   <li>To use <a href="#AES-GCM">AES-GCM</a>, pass an {{domxref("AesGcmParams")}} object.</li>
  </ul>
 </li>
 <li><code><em>key</em></code> is a {{domxref("CryptoKey")}} containing the key to be used for decryption. If using RSA-OAEP, this is the <code>privateKey</code> property of the {{domxref("CryptoKeyPair")}} object.</li>
 <li><em><code>data</code></em> is a {{domxref("BufferSource")}} containing the data to be decrypted (also known as {{glossary("ciphertext")}}).</li>
</ul>

<h3 id="Return_value">Return value</h3>

<ul>
 <li><code><em>result</em></code> is a {{jsxref("Promise")}} that fulfills with an {{jsxref("ArrayBuffer")}} containing the plaintext.</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<p>The promise is rejected when the following exceptions are encountered:</p>

<dl>
 <dt>InvalidAccessError</dt>
 <dd>Raised when the requested operation is not valid for the provided key (e.g. invalid encryption algorithm, or invalid key for the specified encryption algorithm<em>)</em>.</dd>
 <dt>OperationError</dt>
 <dd>Raised when the operation failed for an operation-specific reason (e.g. algorithm parameters of invalid sizes, or there was an error decrypting the ciphertext).</dd>
</dl>

<h2 id="Supported_algorithms">Supported algorithms</h2>

<p>The <code>decrypt()</code> method supports the same algorithms as the <code><a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#Supported_algorithms">encrypt()</a></code> method.</p>

<h2 id="Examples">Examples</h2>

<div class="notecard note">
<p><strong>Note</strong>: You can <a href="https://mdn.github.io/dom-examples/web-crypto/encrypt-decrypt/index.html">try the working examples</a> on GitHub.</p>
</div>

<h3 id="RSA-OAEP">RSA-OAEP</h3>

<p>This code decrypts <code>ciphertext</code> using RSA-OAEP. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/encrypt-decrypt/rsa-oaep.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">function decryptMessage(privateKey, ciphertext) {
  return window.crypto.subtle.decrypt(
    {
      name: "RSA-OAEP"
    },
    privateKey,
    ciphertext
  );
}</pre>

<h3 id="AES-CTR">AES-CTR</h3>

<p>This code decrypts <code>ciphertext</code> using AES in CTR mode. Note that <code>counter</code> must match the value that was used for encryption. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/encrypt-decrypt/aes-ctr.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">function decryptMessage(key, ciphertext) {
  return window.crypto.subtle.decrypt(
    {
      name: "AES-CTR",
      counter,
      length: 64
    },
    key,
    ciphertext
  );
}</pre>

<h3 id="AES-CBC">AES-CBC</h3>

<p>This code decrypts <code>ciphertext</code> using AES in CBC mode. Note that <code>iv</code> must match the value that was used for encryption. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/encrypt-decrypt/aes-cbc.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">function decryptMessage(key, ciphertext) {
  return window.crypto.subtle.decrypt(
    {
      name: "AES-CBC",
      iv: iv
    },
    key,
    ciphertext
  );
}</pre>

<h3 id="AES-GCM">AES-GCM</h3>

<p>This code decrypts <code>ciphertext</code> using AES in GCM mode. Note that <code>iv</code> must match the value that was used for encryption. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/encrypt-decrypt/aes-gcm.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">function decryptMessage(key, ciphertext) {
  return window.crypto.subtle.decrypt(
    {
      name: "AES-GCM",
      iv: iv
    },
    key,
    ciphertext
  );
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Web Crypto API', '#SubtleCrypto-method-decrypt', 'SubtleCrypto.decrypt()') }}</td>
   <td>{{ Spec2('Web Crypto API') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SubtleCrypto.decrypt")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("SubtleCrypto.encrypt()")}}.</li>
 <li><a href="https://tools.ietf.org/html/rfc3447">RFC 3447</a> specifies RSAOAEP.</li>
 <li><a href="https://csrc.nist.gov/publications/detail/sp/800-38a/final">NIST SP800-38A</a> specifies CTR mode.</li>
 <li><a href="https://csrc.nist.gov/publications/detail/sp/800-38a/final">NIST SP800-38A</a> specifies CBC mode.</li>
 <li><a href="https://csrc.nist.gov/publications/detail/sp/800-38d/final">NIST SP800-38D</a> specifies GCM mode.</li>
 <li><a href="https://csrc.nist.gov/csrc/media/publications/fips/198/1/final/documents/fips-198-1_final.pdf">FIPS 198-1</a> specifies HMAC.</li>
</ul>
